#include <stdio.h>
#include <stdint.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include "bmp.h"
#include "types.h"
#include "video_capture.h"
 
int main(int argc, char** argv){
    VideoCapture cap;
    Image rgb888;
    int r, c;

    cap = open_camera("/dev/video/codec");
    usleep(400000);
    if (cap.fd == -1){
        printf("error : Opening video device");
        return 1;
    }

    create_image(&rgb888, cap.width, cap.height, 24, -1);

    read_camera(&cap);

    yuv422_to_rgb888(cap.width, cap.height, cap.data, rgb888.pData);

    save_image("image.bmp", &rgb888);

    free_image(&rgb888);
    close_camera(&cap);
    return 0;
}