#ifndef __BMP_H__
#define __BMP_H__
#include "types.h"

typedef struct _BMP_FILE_HEADER {
    WORD    bfType;
    DWORD   bfSize;
    WORD    bfReserved1;
    WORD    bfReserved2;
    DWORD   bfOffBits;
} BMP_FILE_HEADER;

typedef struct _BMP_INFO_HEADER{
    DWORD       biSize;
    LONG        biWidth;
    LONG        biHeight;
    WORD        biPlanes;
    WORD        biBitCount;
    DWORD       biCompression;
    DWORD       biSizeImage;
    LONG        biXPelsPerMeter;
    LONG        biYPelsPerMeter;
    DWORD       biClrUsed;
    DWORD       biClrImportant;
} BMP_INFO_HEADER;

typedef struct _BMP_RGB_QUAD{
    BYTE    rgbBlue;
    BYTE    rgbGreen;
    BYTE    rgbRed;
    BYTE    rgbReserved;
} BMP_RGB_QUAD;

typedef struct _Image{
    DWORD width;
    DWORD height;
    DWORD bpp;
    BYTE *pData;
} Image;

int load_image(const char *imgName, Image *img);

int save_image(const char *imgName, const Image *img);

int create_image(Image *img, LONG width, LONG height, WORD channel, BYTE val);

int copy_image(const Image *img1, Image *img2);

void rgb565_to_rgb888(const Image *rgb565, Image *rgb888);

void rgb2gray(Image *img1, Image *img2);

void yuv422_to_rgb888(int width, int height, const BYTE* pYUY2, BYTE* pRGB24);

int free_image(const Image *img);

#endif
